<template>
  <div>
    <b-form-group
      v-slot="{ ariaDescribedby }"
      class="m-0 pt-2 pb-2"
      :disabled="disabled"
    >
      <b-form-radio-group
        v-model="localValue"
        :aria-describedby="ariaDescribedby"
        :options="ruleOptions"
        stacked
        @input="updateInput"
      ></b-form-radio-group>
    </b-form-group>
  </div>
</template>
<script>
export default {
  props: {
    value: {
      type: String,
      default: () => '',
      required: true,
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    rule: {
      type: Object,
      default: () => {},
    },
    ruleProperties: {
      type: Object,
      default: () => {},
    },
    options: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      localValue: this.value,
    };
  },
  computed: {
    ruleOptions() {
      const items = this.ruleProperties?.options?.properties?.items;
      if (
        Array.isArray(items) &&
        items.every(
          (item) =>
            Object.prototype.hasOwnProperty.call(item, 'text') &&
            Object.prototype.hasOwnProperty.call(item, 'value')
        )
      ) {
        // use items
        return items.map((item) => {
          return {
            text: item.text,
            value: item.value.toString(),
          };
        });
      } else {
        // use default options
        return [
          { text: 'True', value: '1' },
          { text: 'False', value: '0' },
        ];
      }
    },
  },
  mounted() {
    if (!this.localValue) {
      this.$set(this.rule, 'isDataCompleted', false);
    }
  },
  methods: {
    updateInput(newValue) {
      if (this.disabled) return;
      this.$set(this.rule, 'isDataCompleted', true);
      this.localValue = newValue;
      this.$emit('input', newValue);
    },
  },
};
</script>
